import { Container, IApplicationContext, IContainer } from 'injection';
export declare class MidwayContainer extends Container implements IContainer {
    controllersIds: string[];
    middlewaresIds: string[];
    handlerMap: Map<string, (handlerKey: string, instance?: any) => any>;
    ctx: {};
    isTsMode: any;
    constructor(baseDir?: string, parent?: IApplicationContext, isTsMode?: boolean);
    init(): void;
    /**
     * update current context in applicationContext
     * for mock and other case
     * @param ctx ctx
     * @deprecated
     */
    updateContext(ctx: any): void;
    /**
     * load directory and traverse file to find bind class
     * @param opts
     */
    load(opts: {
        loadDir: string | string[];
        pattern?: string | string[];
        ignore?: string | string[];
    }): void;
    bindClass(exports: any): void;
    protected bindModule(module: any): void;
    createChild(): IContainer;
    protected registerEachCreatedHook(): void;
    /**
     * binding getter method for decorator
     *
     * @param setterProps
     * @param instance
     * @param getterHandler
     */
    private defineGetterPropertyValue;
    registerDataHandler(handlerType: string, handler: (handlerKey: any) => any): void;
    registerCustomBinding(objectDefinition: any, target: any): void;
    dumpDependency(): any;
    /**
     * get hook from current map or parent map
     * @param hookKey
     */
    findHandlerHook(hookKey: string): any;
}
